﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace ComboWithItemsSourceBinding_WPF
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
			List<Location> locations = new List<Location>();

			var Europe = new Location() { Continent = "Eurpope" };
			var Asia = new Location() { Continent = "Asia" };

			locations.Add(Europe);
			locations.Add(Asia);

			Europe.AvailableCountries.Add(new Country() { ID = 1, Name = "Germany" });
			Europe.AvailableCountries.Add(new Country() { ID = 2, Name = "France" });
			Europe.AvailableCountries.Add(new Country() { ID = 3, Name = "Italy" });

			Asia.AvailableCountries.Add(new Country() { ID = 1, Name = "China" });
			Asia.AvailableCountries.Add(new Country() { ID = 2, Name = "South Korea" });

			this.RadGridView1.ItemsSource = locations;

			Europe.PropertyChanged += new PropertyChangedEventHandler(Europe_PropertyChanged);
			Asia.PropertyChanged += new PropertyChangedEventHandler(Asia_PropertyChanged);
		}

		void Asia_PropertyChanged(object sender, PropertyChangedEventArgs e)
		{
			MessageBox.Show(String.Format("Property changed {0}", e.PropertyName));
		}

		void Europe_PropertyChanged(object sender, PropertyChangedEventArgs e)
		{
			MessageBox.Show(String.Format("Property changed {0}", e.PropertyName));
		}
		
	}

	public class Location : INotifyPropertyChanged
	{
		public Location()
		{
			this.AvailableCountries = new List<Country>();
		}

		public string Continent { get; set; }

		private int countryID;
		public int CountryID 
		{ 
			get
			{
				return this.countryID;
			}
			set
			{
				this.countryID = value;
				
				if(this.PropertyChanged != null)
					this.PropertyChanged(this, new PropertyChangedEventArgs("CountryID"));
			}
		}

		public List<Country> AvailableCountries 
		{ 
			get;
			set; 
		}


		public event PropertyChangedEventHandler PropertyChanged;
	}

	public class Country
	{
		public int ID { get; set; }
		public string Name { get; set; }
	}
}
